
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Daily_followup_clinicDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const daily_followup_clinic = await db.daily_followup_clinic.create(
            {
                id: data.id || undefined,
        
        record_number: data.record_number
        ||
        null
            ,
            
        condition_type: data.condition_type
        ||
        null
            ,
            
        route: data.route
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
        send_to_accounting: data.send_to_accounting
        ||
        false
        
            ,
            
        price: data.price
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await daily_followup_clinic.setPatient( data.patient || null, {
            transaction,
        });
        

        

        

        return daily_followup_clinic;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const daily_followup_clinicData = data.map((item, index) => ({
                id: item.id || undefined,
                
                record_number: item.record_number
            ||
            null
            ,
            
                condition_type: item.condition_type
            ||
            null
            ,
            
                route: item.route
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
                send_to_accounting: item.send_to_accounting
            ||
            false
        
            ,
            
                price: item.price
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const daily_followup_clinic = await db.daily_followup_clinic.bulkCreate(daily_followup_clinicData, { transaction });

        // For each item created, replace relation files
        

        return daily_followup_clinic;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const daily_followup_clinic = await db.daily_followup_clinic.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.record_number !== undefined) updatePayload.record_number = data.record_number;
        
        
        if (data.condition_type !== undefined) updatePayload.condition_type = data.condition_type;
        
        
        if (data.route !== undefined) updatePayload.route = data.route;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        if (data.send_to_accounting !== undefined) updatePayload.send_to_accounting = data.send_to_accounting;
        
        
        if (data.price !== undefined) updatePayload.price = data.price;
        
        
        updatePayload.updatedById = currentUser.id;

        await daily_followup_clinic.update(updatePayload, {transaction});

        
        
        if (data.patient !== undefined) {
            await daily_followup_clinic.setPatient(
              
              data.patient,
              
              { transaction }
            );
        }
        

        
        

        

        return daily_followup_clinic;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const daily_followup_clinic = await db.daily_followup_clinic.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of daily_followup_clinic) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of daily_followup_clinic) {
                await record.destroy({transaction});
            }
        });


        return daily_followup_clinic;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const daily_followup_clinic = await db.daily_followup_clinic.findByPk(id, options);

        await daily_followup_clinic.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await daily_followup_clinic.destroy({
            transaction
        });

        return daily_followup_clinic;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const daily_followup_clinic = await db.daily_followup_clinic.findOne(
            { where },
            { transaction },
        );

        if (!daily_followup_clinic) {
            return daily_followup_clinic;
        }

        const output = daily_followup_clinic.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.patient = await daily_followup_clinic.getPatient({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.patients,
        as: 'patient',
        
        where: filter.patient ? {
          [Op.or]: [
            { id: { [Op.in]: filter.patient.split('|').map(term => Utils.uuid(term)) } },
            {
              full_name: {
                [Op.or]: filter.patient.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.record_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'daily_followup_clinic',
                        'record_number',
                        filter.record_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'daily_followup_clinic',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.priceRange) {
                const [start, end] = filter.priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    price: {
                    ...where.price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    price: {
                    ...where.price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.condition_type) {
                where = {
                    ...where,
                condition_type: filter.condition_type,
            };
            }
            
            if (filter.route) {
                where = {
                    ...where,
                route: filter.route,
            };
            }
            
            if (filter.send_to_accounting) {
                where = {
                    ...where,
                send_to_accounting: filter.send_to_accounting,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.daily_followup_clinic.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'daily_followup_clinic',
                        'record_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.daily_followup_clinic.findAll({
            attributes: [ 'id', 'record_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['record_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.record_number,
        }));
    }

    
};

